%define name	sane
%define version	1.0.25
%define release	%mkrel 1
%define beta	%nil

%define libmajor 1
%define libname %mklibname %{name} %{libmajor}
%define	libname_devel %mklibname %{name} %{libmajor} -d

%define iscanversion 2.28.1

%define _exclude_files_from_autoprov  %{_libdir}/%{name}/
%define __libtoolize /bin/true

%define empty_dll_conf 0

%define gphoto2_support 1
%define v4l_support 1
%define primax_support 0
%define epkowa_support 1

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	SANE - local and remote scanner access
URL:		http://www.sane-project.org/
Source:		ftp://ftp.sane-project.org/pub/sane/sane-%{version}/sane-backends-%{version}%{beta}.tar.xz
Source3:	http://belnet.dl.sourceforge.net/sourceforge/px-backend/primaxscan-1.1.beta1.tar.bz2
Source5:	saned-xinetd
Source9:	http://heanet.dl.sourceforge.net/sourceforge/hp44x0backend/sane_hp_rts88xx-0.18.tar.bz2
Source10:	http://heanet.dl.sourceforge.net/sourceforge/brother-mfc/sane-driver-0.2.tar.bz2
Source11:	http://www.geocities.com/trsh0101/SANE/primascan.h
Source12:	http://www.geocities.com/trsh0101/SANE/primascan.c
Source13:	iscan-%{iscanversion}-3.tar.bz2
Source14:	http://downloads.sourceforge.net/project/geniusvp2/sane-backend-geniusvp2/1.0.16.1/sane-backend-geniusvp2_1.0.16.1.tar.gz
Patch0:		sane-backends-1.0.19-fix-str-fmt.patch
Patch1:		sane-backends-1.0.18-plustek-s12.patch
Patch23:	iscan-2.28.1-fix-link.patch
Patch24:	sane-backends-1.0.21-link.patch
Patch27:	iscan-2.28.1-linkage_fix.patch
Patch28:	sane-backends-1.0.20-group.patch
Patch29:	sane-backends-1.0.21-primascan.patch
Patch30:	sane-backends-1.0.22-brother2list.patch
Patch31:	sane-backends-1.0.20-strformat.patch
Patch33:	sane-backends-1.0.23-have-pthread.patch
Patch34:	sane-1.0.24-primaxscan-gcc5.patch
Patch101:	01_missing_pthreads.dpatch
Patch106:	06_cap_always_settable.dpatch
Patch109:	09_po_update_es_add_gl.dpatch
Patch113:	22_dll_backend_conf.dpatch
Patch115:	24_sane-desc.c_debian_mods.dpatch
Patch202:	sane-backends-1.0.20-open-macro.patch
Patch203:	sane-backends-1.0.23-udev.patch
License: 	GPLv2+ and GPLv2+ with exceptions and Public Domain
Group:		Graphics/Scanning
Requires:	%{libname} = %{version}-%{release}
Requires:	sane-backends = %{version}-%{release}
BuildRequires:	jpeg-devel
BuildRequires:	tiff-devel
BuildRequires:	libusb-devel
BuildRequires:	libieee1284-devel
BuildRequires:	libltdl-devel
BuildRequires:	texlive
BuildRequires:	texlive-texmf
BuildRequires:	gettext
BuildRequires:	gettext-devel
BuildRequires:	libgtk+2.0-devel
%if %{gphoto2_support}
#BuildRequires:	gphoto2-devel
%endif
%if %{v4l_support}
BuildRequires:	libv4l-devel
%endif
%if %{epkowa_support}
BuildRequires:	autoconf
%endif
# ensure resmgr is not pulled
BuildConflicts:	resmgr-devel

%description
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package does not enable network scanning by default; if you wish
to enable it, install the saned package.

%package -n	%{libname}
Group:		System/Libraries
License:	LGPL
Summary:	SANE - local and remote scanner access. This package contains the sane library
Provides:	libsane = %{version}-%{release}

%description -n	%{libname}
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package does not enable network scanning by default; if you wish
to enable it, install the saned package.

%package -n	%{libname_devel}
Group:		Development/Libraries
License:	LGPL
Summary:	SANE - local and remote scanner access
Requires:	%{libname} = %{version}
Provides:	libsane-devel = %{version}-%{release}
Provides:	sane-devel = %{version}-%{release}
Obsoletes:	sane-devel

%description -n	%{libname_devel}
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package contains the headers and development libraries necessary 
to develop applications using SANE.

%package	backends
Group:		Graphics
License:	LGPL
Summary:	SANE - local and remote scanner access
Provides:	%{name} = %{version}-%{release}
Requires(pre,postun):	rpm-helper
%if %{epkowa_support}
Suggests:	iscan
%endif

%description	backends
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package does not enable network scanning by default; if you wish
to enable it, install the saned package and set up the sane-net backend.
This package contains the backends for different scanners.

%if %{epkowa_support}
%package	backends-iscan
Group:		Graphics
License:	LGPL
Summary:	SANE - local and remote scanner access
Provides:	iscan = %{iscanversion}

%description	backends-iscan
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package does not enable network scanning by default; if you wish
to enable it, install the saned package and set up the sane-net backend.

This package contains the iscan backend, in order to not conflict with
manufacturer-supplied packages.
%endif

%package	backends-doc
Summary:	Documentation for SANE backends
Group:		Documentation
BuildArch:	noarch

%description	backends-doc
This package contains the SANE backend documentation for different
scanners.

SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package does not enable network scanning by default; if you wish
to enable it, install the saned package and set up the sane-net backend.

%package -n	saned
Group:		Graphics
License:	LGPL
Summary:	SANE - local and remote scanner access
Provides:	saned = %{version}-%{release}
Requires:	sane-backends
Requires:	xinetd
Requires(pre,post,preun,postun):	rpm-helper

%description -n	saned
SANE (Scanner Access Now Easy) is a sane and simple interface
to both local and networked scanners and other image acquisition devices
like digital still and video cameras.  SANE currently includes modules for
accessing a range of scanners, including models from Agfa SnapScan, Apple,
Artec, Canon, CoolScan, Epson, HP, Microtek, Mustek, Nikon, Siemens,
Tamarack, UMAX, Connectix, QuickCams and other SANE devices via network.

For the latest information on SANE, the SANE standard definition, and
mailing list access, see http://www.mostang.com/sane/

This package contains saned, a daemon that allows remote clients to
access image acquisition devices available on the local host.

%prep
%setup -q -n sane-backends-%{version}%{beta}
%patch1 -p1 -b .plusteks12
%patch28 -p1 -b .group
%patch30 -p1 -b .brother2list
%patch31 -p1 -b .strformat
%patch33 -p1 -b .pthread

%patch101 -p1
%patch106 -p1
%patch113 -p1
%patch115 -p1

# Fedora patches
%patch202 -p1 -b .open-macro
%patch203 -p1 -b .udev

# Primax parallel port scanners
%if %{primax_support}
%setup -q -T -D -a 3 -n sane-backends-%{version}
%patch34 -p1
%endif

cat %{SOURCE11} > backend/primascan.h
cat %{SOURCE12} > backend/primascan.c
echo '#primascan' >> backend/dll.conf.in

# Epson Avasys driver for Epson scanners
%if %{epkowa_support}
%setup -q -T -D -a 13 -n sane-backends-%{version}%{beta}
%endif

# lib64 fixes (avoid patch)
# NOTE: don't regenerate configure script past this line
perl -pi -e "s@/lib(\"|\b[^/])@/%_lib\1@g if /LDFLAGS=.*with_ptal/" configure

# Reduce number of retries done by the "snapscan" backend when accessing
# the scanner
perl -p -i -e 's:for \(retries = 20; retries; retries--\):for (retries = 5; retries; retries--):' backend/snapscan-scsi.c

%if %{epkowa_support}
pushd iscan-%{iscanversion}
%patch23 -p0 -b .iscan-2.10.0-1_fix_link
%patch27 -p2 -b .linkage_fix
popd
%endif

# Remove the backend/dll.conf file generated by the patches, it prevents
# the Makefile from generating  the real dll.conf file
rm -f backend/dll.conf

%build
autoreconf -fi 
%configure2_5x \
  --enable-rpath=no \
%if !%{gphoto2_support}
 --without-gphoto2
%endif


%make

# Primax parallel port scanners
%if %{primax_support}
chmod a+rx tools/sane-config
cd primaxscan*
PATH=`pwd`/../tools:${PATH}
CFLAGS="${RPM_OPT_FLAGS/-ffast-math/} -fPIC -I`pwd`/../include -L`pwd`/../backend/.libs/"\
%configure2_5x
%make
%make primax_scan
cd ..
%endif

# Epson Avasys driver for Epson scanners
%if %{epkowa_support}
chmod a+rx tools/sane-config
PATH=`pwd`/tools:${PATH}
cd iscan-%{iscanversion}
#autoconf
sh ./bootstrap
export CFLAGS="${RPM_OPT_FLAGS/-ffast-math/} -I`pwd`/../include -L`pwd`/../backend/ -fPIC"
export CXXFLAGS="${RPM_OPT_FLAGS/-ffast-math/} -I`pwd`/../include -L`pwd`/../backend/ -fPIC"
%configure2_5x --disable-frontend
%make
cd ..
%endif

%install
rm -rf %buildroot
%makeinstall_std

# Create missing lock dir
install -d %{buildroot}/var/lock/sane

perl -pi -e "s/installed.*/installed=yes/g" %{buildroot}%{_libdir}/libsane.la
/sbin/ldconfig -n %{buildroot}%{_libdir} %{buildroot}%{_libdir}/sane

perl -p -i -e 's/^(\s*geniusvp2)/\#$1/g' %{buildroot}%{_sysconfdir}/sane.d/dll.conf

#perl -p -i -e 's/^(\s*epson)/\#$1/g' %{buildroot}%{_sysconfdir}/sane.d/dll.conf

# Remove "hpoj" line from /etc/sane.d/dll.con
perl -p -i -e 's/HP\s+OfficeJet/HPLIP/g' %{buildroot}%{_sysconfdir}/sane.d/dll.conf
perl -p -i -e 's/hpoj.sf.net/hplip.sf.net/g' %{buildroot}%{_sysconfdir}/sane.d/dll.conf
perl -p -i -e 's/hpoj/hpaio/g' %{buildroot}%{_sysconfdir}/sane.d/dll.conf

%if %{empty_dll_conf}
mv %{buildroot}%{_sysconfdir}/sane.d/dll.conf %{buildroot}%{_sysconfdir}/sane.d/dll.conf.orig
cat > %{buildroot}%{_sysconfdir}/sane.d/dll.conf <<EOF
net
EOF
%endif

# Move documentation from /usr/doc to /usr/share/doc
install -d %{buildroot}%{_docdir}/sane-backends-%{version}/
install -d %{buildroot}%{_docdir}/sane-backends-doc-%{version}/
pushd %{buildroot}/usr/doc/sane-%{version}
mv `find -mindepth 1 -type d` *.html *.txt %{buildroot}%{_docdir}/sane-backends-doc-%{version}/
mv README README.linux %{buildroot}%{_docdir}/sane-backends-%{version}/
rm -f README.*
mv * %{buildroot}%{_docdir}/sane-backends-%{version}/
popd

# Primax parallel port scanners
%if %{primax_support}
cd primaxscan*
%makeinstall_std
rm -f %{buildroot}%{_libdir}/libsane-primax.a %{buildroot}%{_prefix}/lib/sane/libsane-primax.a
cp primax_scan %{buildroot}%{_bindir}
cd ..
%endif

# Epson Avasys driver for Epson scanners
%if %{epkowa_support}
cd iscan-%{iscanversion}
%makeinstall_std
rm -f %{buildroot}%{_libdir}/sane/libsane-epkowa.a
rm -f %{buildroot}%{_mandir}/man1/iscan.1*
rm -rf %{buildroot}%{_libdir}/iscan
cp backend/epkowa.conf %{buildroot}%{_sysconfdir}/sane.d/
echo 'epkowa' >> %{buildroot}%{_sysconfdir}/sane.d/dll.conf
cd ..
%endif

# Xinetd.d entry
mkdir %{buildroot}/etc/xinetd.d
cat %{SOURCE5} > %{buildroot}/etc/xinetd.d/saned

# udev rules for libusb user support
mkdir -p %{buildroot}/lib/udev/rules.d
install -m644 tools/udev/libsane.rules %{buildroot}/lib/udev/rules.d/60-libsane.rules
# Shorten too long comments
perl -p -i -e 's/(\#.{500}).*$/$1 .../' %{buildroot}/lib/udev/rules.d/60-libsane.rules

%find_lang sane-backends
%if %{epkowa_support}
%find_lang iscan
%endif

sed -i '/^%dir/d' sane-backends.lang
%if %{epkowa_support}
sed -i '/^%dir/d' iscan.lang
%endif

find %{buildroot} -name '*.la' | xargs rm

%post -n saned
%_post_service saned


%pre -n saned
# Add saned to group scanner, cdwriter and usb for scanner access.
/usr/sbin/useradd -r -M -s /bin/false  -c "system user for saned" saned -G cdwriter,usb,scanner || :
#%_pre_useradd saned /etc/sane.d /bin/false

%preun -n saned
%_preun_service saned

%postun -n saned
%_postun_userdel saned

%pre backends
%_pre_groupadd scanner

%postun backends
%_postun_groupdel scanner

%posttrans -n saned
#make sure this isnt commented out or epson scanners wont work
perl -pi -e "s|#epson|epson|" /etc/sane.d/dll.conf
perl -pi -e "s|epson2|#epson2|" /etc/sane.d/dll.conf


%files backends -f sane-backends.lang
%doc %{_docdir}/sane-backends-%{version}
%{_bindir}/sane-find-scanner
%{_bindir}/scanimage
%{_bindir}/gamma4scanimage
%{_bindir}/umax_pp
%if %{primax_support}
%{_bindir}/primax_scan
%endif
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%dir %{_sysconfdir}/sane.d
%dir %{_sysconfdir}/sane.d/dll.d
%config(noreplace) %{_sysconfdir}/sane.d/*
/lib/udev/rules.d/*-libsane.rules
%attr(1777,root,root) %dir /var/lock/sane
%if %{epkowa_support}
# iscan files
%exclude %{_sysconfdir}/sane.d/epkowa.conf
%exclude %{_mandir}/man5/sane-epkowa.5*
%endif

%if %{epkowa_support}
%files backends-iscan -f iscan.lang
%{_libdir}/sane/libsane-epkowa.*
%{_sysconfdir}/sane.d/epkowa.conf
%{_mandir}/man5/sane-epkowa.5*
%{_mandir}/man8/iscan-registry.*
%endif

%files backends-doc
%doc %{_docdir}/sane-backends-doc-%{version}

%files -n %{libname}
%{_libdir}/*.so.*
%dir %{_libdir}/sane
%{_libdir}/sane/*.so.*
%if %{epkowa_support}
%exclude %{_libdir}/sane/libsane-epkowa.*
%endif

%files -n %{libname_devel}
%{_bindir}/sane-config
%{_libdir}/*.so
%{_libdir}/sane/*.so
%{_includedir}/sane
%{_libdir}/pkgconfig/sane-backends.pc
%if %{epkowa_support}
%exclude %{_libdir}/sane/libsane-epkowa*
%endif

%files -n saned
%{_sbindir}/*
%{_mandir}/man8/saned*
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/saned


%changelog
* Fri Nov 11 2016 adrianomorselli <adrianomorselli> 1.0.25-1uplos2016
- rebuild without gphoto2 it breaks 32 system

* Wed May 25 2016 bb <bb> 1.0.25-1pclos2016
- update

* Wed Jun 18 2014 bb <bb> 1.0.24-5pclos2014
- comment out epson2

* Tue Jun 17 2014 bb <bb> 1.0.24-4pclos2014
- dont comment out epson in dll.conf

* Tue Jun 16 2014 bb <bb> 1.0.24-3pclos2014
- use normal iscan package

* Mon Jun 15 2014 bb <bb> 1.0.24-2pclos2014
- fix lock directory /var/lock/sane

* Tue May 26 2014 bb <bb> 1.0.24-1pclos2014
- update for new gphoto library
